<ul class="breadcrumb">
    <li><a href="<?= $this->url('root') ?>"><?= $this->icon('home') ?></a></li>
    <li><?= $this->translate('administration_module_title') ?></li>
    <li class="active"><?= $this->translate('alert_module_title') ?></li>
</ul>

<h1 class="page-title">
    <?= $this->icon('alert') ?> <?= $this->translate('alert_module_title') ?>
</h1>

<div class="row row-padding">
    <div class="col-xs-12">
        <div class="panel" ng-controller="alertListController as self">
            <table-builder options="self.options" items="self.alerts" class="table-builder">
                <div class="panel-heading">
                    <?= $this->translate('alert_nav_list') ?>
                    <div class="panel-heading-right">
                        <div class="panel-heading-actions" tooltip="<?= $this->translate('tooltip_remove_from_list') ?>">
                            <?= $this->icon('eraser', 'fa-fw pointer', ['ng-click' => '__tb.removeFromList()']) ?>
                        </div>
                        <div class="panel-heading-actions" tooltip="<?= $this->translate('tooltip_export_xls') ?>">
                            <?= $this->icon('excel', 'fa-fw pointer', ['ng-click' => '__tb.exportExcel()']) ?>
                        </div>
                        <div class="panel-heading-actions" tooltip="<?= $this->translate('tooltip_refresh') ?>">
                            <?= $this->icon('refresh', 'fa-fw pointer', ['ng-click' => '__tb.loadData()']) ?>
                        </div>
                    </div>
                </div>
                <div class="panel-body">
                    <div class="row">
                        <div class="col-sm-4">
                            <div class="table-filters little-panel">
                                <div class="title table-filters-header">
                                    <div class="input-group">
                                        <div class="input-group-addon pointer" data-toggle="collapse" href="#filters-collapsed">
                                            <?= $this->icon('filters', 'fa-fw') ?>
                                            <span class="caret"></span>
                                        </div>
                                        <input type="text" placeholder="<?= $this->translate('search', null, null, false) ?>" class="form-control"
                                               ng-model="self.fullText" id="full-text" on-enter="self.fullTextSearch()"/>
                                        <div class="input-group-addon pointer" ng-click="self.fullTextSearch()">
                                            <?= $this->icon('search', 'fa-fw') ?>
                                        </div>
                                    </div>
                                </div>
                                <div id="filters-collapsed" class="body collapse">
                                    <?=
                                    $this->tableFilter('__tb.apiParams.search.data.filters', [
                                        'name'        => [
                                            'label' => $this->translate('alert_field_name'),
                                            'type'  => 'string',
                                        ],
                                        'subject'     => [
                                            'label' => $this->translate('alert_field_subject'),
                                            'type'  => 'string',
                                        ],
                                        'enabled'     => [
                                            'label' => $this->translate('alert_field_enabled'),
                                            'type'  => 'boolean',
                                        ],
                                        /*'periodicity' => [
                                            'label' => $this->translate('alert_field_periodicity'),
                                            'type'  => \Alert\Entity\Alert::getPeriodicities(),
                                        ],*/
                                        'createdAt'   => [
                                            'label' => $this->translate('alert_field_createdAt'),
                                            'type'  => 'date',
                                        ],
                                        'updatedAt'   => [
                                            'label' => $this->translate('alert_field_updatedAt'),
                                            'type'  => 'date',
                                        ],
                                    ])
                                    ?>

                                    <div class="row">
                                        <div class="col-xs-6">
                                            <button class="btn" ng-click="self.resetfullTextSearch(); __tb.resetFilters(); __tb.loadData()"><?= $this->translate('table_filter_reset_button') ?></button>
                                        </div>
                                        <div class="col-xs-6 text-right">
                                            <button class="btn" ng-click="self.resetfullTextSearch(); __tb.loadData()">
                                                <?= $this->icon('search', 'fa-fw') ?>
                                                <?= $this->translate('table_filter_button') ?>
                                            </button>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="col-sm-4">
                            <table-builder-columns></table-builder-columns>
                        </div>
                        <?php if ($this->acl()->isAllowed('application:e:query:r')) : ?>
                            <div class="col-sm-4">
                                <table-builder-queries></table-builder-queries>
                            </div>
                        <?php endif; ?>
                    </div>
                    <div class="row">
                        <div class="col-xs-12">
                            <form name="alertForm">
                                <table table-builder-table class="table table-bordered table-condensed table-hover">
                                    <thead>
                                        <tr>
                                            <th tb-column tb-name="selection" class="checkbox-column"><input type="checkbox" ng-model="__tb.selection"/></th>
                                            <th tb-column tb-name="name" tb-sortable="true" tb-toggle="true"><?= $this->translate('alert_field_name') ?></th>
                                            <th tb-column tb-name="subject" tb-sortable="true" tb-toggle="true"><?= $this->translate('alert_field_subject') ?></th>
                                            <th tb-column tb-name="periodicity" tb-sortable="true" tb-toggle="true"><?= $this->translate('alert_field_periodicity') ?></th>
                                            <th tb-column tb-name="toManagers" tb-toggle="true"><?= $this->translate('alert_field_toManagers') ?></th>
                                            <th tb-column tb-name="toValidators" tb-toggle="true"><?= $this->translate('alert_field_toValidators') ?></th>
                                            <th tb-column tb-name="toMembers" tb-toggle="true"><?= $this->translate('alert_field_toMembers') ?></th>
                                            <th tb-column tb-name="toWorkFlows" tb-toggle="true"><?= $this->translate('alert_field_toWorkflows') ?></th>
                                            <th tb-column tb-name="recipients.name" tb-toggle="true"><?= $this->translate('alert_field_recipients') ?></th>
                                            <th tb-column tb-name="enabled" tb-toggle="true"><?= $this->translate('alert_field_enabled') ?></th>
                                            <th tb-column tb-name="createdAt" tb-sortable="true" tb-toggle="true" tb-hidden="true"><?= $this->translate('alert_field_createdAt') ?></th>
                                            <th tb-column tb-name="updatedAt" tb-sortable="true" tb-toggle="true" tb-hidden="true"><?= $this->translate('alert_field_updatedAt') ?></th>
                                            <th tb-column tb-name="actions" class="actions-column"></th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr ng-repeat="alert in self.alerts" ng-class="{editing: self.editedLine == alert}">
                                            <td><input type="checkbox" ng-model="alert.selected"/></td>
                                            <td class="editable">
                                                <span ng-show="self.editedLine !== alert">
                                                    <a ng-if="alert._rights.read && alert.category != 'campain'" href="<?= $this->url('alert/form') ?>/{{alert.id}}">{{alert.name}}</a>
                                                    <a ng-if="alert._rights.read && alert.category == 'campain'" href="<?= $this->url('alert/formcampain') ?>/{{alert.id}}">{{alert.name}}</a>
                                                    <span ng-if="!alert._rights.read">{{alert.name}}</span>

                                                    <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(alert)', 'ng-if' => 'alert._rights.update']) ?>
                                                </span>
                                                <span ng-if="self.editedLine == alert">
                                                    <input type="text" class="form-control input-sm" ng-model="self.editedLineFields.name" required/>
                                                    <field-errors field="name" errors="self.editedLineErrors"></field-errors>
                                                </span>
                                            </td>
                                            <td class="editable">
                                                <span ng-show="self.editedLine !== alert">
                                                    {{alert.subject}}
                                                    <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(alert)', 'ng-if' => 'alert._rights.update']) ?>
                                                </span>
                                                <span ng-if="self.editedLine == alert">
                                                    <input type="text" class="form-control input-sm" ng-model="self.editedLineFields.subject" required/>
                                                    <field-errors field="subject" errors="self.editedLineErrors"></field-errors>
                                                </span>
                                            </td>
                                            <td class="editable">
                                                <span ng-show="self.editedLine !== alert">
                                                    {{alert.periodicity | translate | ucfirst}}
                                                    <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(alert)', 'ng-if' => 'alert._rights.update']) ?>
                                                </span>
                                                <span ng-if="self.editedLine == alert">
                                                    <select class="form-control input-sm" name="periodicity" ng-model="self.editedLineFields.periodicity" required>
                                                        <?php foreach ($periodicities as $periodicity) {
                                                            echo '<option value="' . $periodicity . '">' . ucfirst($this->translate($periodicity)) . '</option>';
                                                        } ?>
                                                    </select>
                                                    <field-errors field="periodicity" errors="self.editedLineErrors"></field-errors>
                                                </span>
                                            </td>
                                            <td class="text-center">
                                                <input type="checkbox" ng-model="alert.toManagers" ng-disabled="!alert._rights.update" ng-change="self.enableToManagers(alert)"/>
                                                <field-errors field="toManagers" errors="self.errors.fields"></field-errors>
                                            </td>
                                            <td class="text-center">
                                                <input type="checkbox" ng-model="alert.toValidators" ng-disabled="!alert._rights.update" ng-change="self.enableToValidators(alert)"/>
                                                <field-errors field="toValidators" errors="self.errors.fields"></field-errors>
                                            </td>
                                            <td class="text-center">
                                                <input type="checkbox" ng-model="alert.toMembers" ng-disabled="!alert._rights.update" ng-change="self.enableToMembers(alert)"/>
                                                <field-errors field="toMembers" errors="self.errors.fields"></field-errors>
                                            </td>
                                            <td class="text-center">
                                                <input type="checkbox" ng-model="alert.toWorkFlows" ng-disabled="!alert._rights.update" ng-change="self.enableToWorkFlows(alert)"/>
                                                <field-errors field="toWorkFlows" errors="self.errors.fields"></field-errors>
                                            </td>
                                            <td class="editable">
                                                <span ng-show="self.editedLine !== alert" class="comma-separated">
                                                    <span ng-repeat="recipient in alert.recipients"><!--
                                                        -->{{recipient.name}}<!--
                                                    --></span>
                                                    <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(alert)', 'ng-if' => 'alert._rights.update']) ?>
                                                </span>
                                                <span ng-if="self.editedLine == alert">
                                                    <user-select name="recipients" ng-model="self.editedLineFields.recipients" ng-disabled="!alert._rights.update" multiple="true" required="false" form="alertForm"></user-select>
                                                    <field-errors field="recipients" errors="self.editedLineErrors"></field-errors>
                                                </span>
                                            </td>
                                            <td class="text-center">
                                                <input type="checkbox" name="enabled" ng-model="alert.enabled" ng-change="self.enableAlert(alert)" ng-disabled="!alert._rights.update"/>
                                                <field-errors field="enabled" errors="self.editedLineErrors"></field-errors>
                                            </td>
                                            <td>{{alert.createdAt | dateFormat : 'DD/MM/YYYY'}}</td>
                                            <td>{{alert.updatedAt | dateFormat : 'DD/MM/YYYY'}}</td>
                                            <td>
                                                <div class="btn-group btn-group-actions" ng-if="self.editedLine !== alert">
                                                    <?php if ($this->acl()->isAllowed('alert:e:alert:r')) : ?>
                                                    <a ng-if="alert._rights.read && alert.category != 'campain'" href="<?= $this->url('alert/form') ?>/{{alert.id}}" class="btn btn-xs btn-default" tooltip="<?= $this->translate('tooltip_edit') ?>">
                                                        <?= $this->icon('edit') ?>
                                                    </a>
                                                    <a ng-if="alert._rights.read && alert.category == 'campain'" href="<?= $this->url('alert/formcampain') ?>/{{alert.id}}" class="btn btn-xs btn-default" tooltip="<?= $this->translate('tooltip_edit') ?>"> 
                                                        <?= $this->icon('edit') ?>
                                                    </a>
                                                    <?php endif; ?>

                                                    <?php if ($this->acl()->isAllowed('alert:e:alert:d')) : ?>
                                                        <a ng-if="alert._rights.delete" href="" class="btn btn-xs btn-default" tooltip="<?= $this->translate('tooltip_delete') ?>" ng-click="self.deleteAlert(alert);">
                                                            <?= $this->icon('delete') ?>
                                                        </a>
                                                    <?php endif; ?>
                                                </div>
                                                <div class="btn-group btn-group-actions" ng-if="self.editedLine == alert">
                                                    <button class="btn btn-xs btn-default" ng-click="self.saveEditedLine(alert)" type="submit" tooltip="<?= $this->translate('tooltip_save') ?>">
                                                        <?= $this->icon('save') ?>
                                                    </button>
                                                    <button class="btn btn-xs btn-default" ng-click="self.editedLine = null" type="button" tooltip="<?= $this->translate('tooltip_cancel') ?>">
                                                        <?= $this->icon('close') ?>
                                                    </button>
                                                </div>
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </form>
                        </div>
                    </div>
                </div>
            </table-builder>
        </div>
    </div>
</div>

<?php
$fabLinks = [];

if ($this->acl()->isAllowed('alert:e:alert:c')) {
    $fabLinks[] = [
        'href' => $this->url('alert/form'),
        'text' => $this->icon('create', 'fa-fw') . ' ' . $this->translate('alert_nav_form'),
    ];

    $fabLinks[] = [
        'href' => $this->url('alert/formcampain'),
        'text' => $this->icon('create', 'fa-fw') . ' ' . $this->translate('alert_nav_form_campain'),
    ];
}

echo $this->fabMenu($fabLinks);
?>

<?php
$this->angular('js/src/user/service/user.js');
$this->angular('js/src/user/directive/userSelect.js');

$this->angular('js/src/alert/service/alert.js');
$this->angular('js/src/application/query/service/query.js');

$this->angular('js/src/alert/controller/list.js');
